//-------------------------------------------------------------------------------------------------
// <copyright file="SR.cs" company="syncfusion">
//  Copyright (c) Syncfusion Inc. 2001 - 2006. All rights reserved.
//  Use of this code is subject to the terms of our license.
//  A copy of the current license can be obtained at any time by e-mailing
//  licensing@syncfusion.com. Re-distribution in any form is strictly
//  prohibited. Any infringement will be prosecuted under applicable laws. 
// </copyright>
//-------------------------------------------------------------------------------------------------

using System;
using System.ComponentModel;
using System.Resources;
using System.Globalization;
using System.Diagnostics;

using Syncfusion.Diagnostics;

// Tip:
// To simplify rebuilding this class while working on your project
// you should add the following External Tool in Developer Studio:
// 
//     Title: Resgen SR.TXT
//     Command: C:\WINNT\system32\CMD.EXE
//     Arguments: /c resgen SR.txt & srgen @srgen.ini & echo Done.
//     Initial Directory: $(ProjectDir)
//     Please enable "X Use Output for Window."
// 
// Additionally you should add a file srgen.ini to project that 
// contains command line arguments for your project.
//
// Example: 
// SRGen.ini
//// sr.txt namespace:Samples.SRGenSample classname:SR

namespace Syncfusion.Windows.Forms.Grid
{
    /// <summary>
    ///    SR provides localized access to string resources specific 
    ///    from the assembly manifest Syncfusion.Windows.Forms.Grid.SR.resources
    /// </summary>
    sealed class SR
    {
        // Fields
        private ResourceManager resources;
        private static SR loader = null;

        // Strings 
        internal const string BitVectorFull = "BitVectorFull";
        internal const string ColorEditorPaletteTab = "ColorEditorPaletteTab";
        internal const string ColorEditorStandardTab = "ColorEditorStandardTab";
        internal const string ColorEditorSystemTab = "ColorEditorSystemTab";
        internal const string CommandAddCoveredRanges = "CommandAddCoveredRanges";
        internal const string CommandChangeCells = "CommandChangeCells";
        internal const string CommandColumnWidth = "CommandColumnWidth";
        internal const string CommandDefaultSizeColumn = "CommandDefaultSizeColumn";
        internal const string CommandDefaultSizeRow = "CommandDefaultSizeRow";
        internal const string CommandFixedCountColumn = "CommandFixedCountColumn";
        internal const string CommandFixedCountRow = "CommandFixedCountRow";
        internal const string CommandHeaderCountColumn = "CommandHeaderCountColumn";
        internal const string CommandHeaderCountRow = "CommandHeaderCountRow";
        internal const string CommandHideColumn = "CommandHideColumn";
        internal const string CommandHideRow = "CommandHideRow";
        internal const string CommandInsertColumn = "CommandInsertColumn";
        internal const string CommandInsertRow = "CommandInsertRow";
        internal const string CommandMoveColumn = "CommandMoveColumn";
        internal const string CommandMoveRow = "CommandMoveRow";
        internal const string CommandRemoveColumn = "CommandRemoveColumn";
        internal const string CommandRemoveCoveredRanges = "CommandRemoveCoveredRanges";
        internal const string CommandRemoveRow = "CommandRemoveRow";
        internal const string CommandRowHeight = "CommandRowHeight";
        internal const string DateTimeFormat_D = "DateTimeFormat_D";
        internal const string DateTimeFormat_dd = "DateTimeFormat_dd";
        internal const string DateTimeFormat_F = "DateTimeFormat_F";
        internal const string DateTimeFormat_ff = "DateTimeFormat_ff";
        internal const string DateTimeFormat_G = "DateTimeFormat_G";
        internal const string DateTimeFormat_gg = "DateTimeFormat_gg";
        internal const string DateTimeFormat_M = "DateTimeFormat_M";
        internal const string DateTimeFormat_R = "DateTimeFormat_R";
        internal const string DateTimeFormat_ss = "DateTimeFormat_ss";
        internal const string DateTimeFormat_T = "DateTimeFormat_T";
        internal const string DateTimeFormat_tt = "DateTimeFormat_tt";
        internal const string DateTimeFormat_U = "DateTimeFormat_U";
        internal const string DateTimeFormat_uu = "DateTimeFormat_uu";
        internal const string DateTimeFormat_Y = "DateTimeFormat_Y";
        internal const string DescriptionChangeCells = "DescriptionChangeCells";
        internal const string DescriptionInsertColumn = "DescriptionInsertColumn";
        internal const string DescriptionInsertRow = "DescriptionInsertRow";
        internal const string DescriptionMoveColumn = "DescriptionMoveColumn";
        internal const string DescriptionMoveRow = "DescriptionMoveRow";
        internal const string DescriptionRemoveColumn = "DescriptionRemoveColumn";
        internal const string DescriptionRemoveRow = "DescriptionRemoveRow";
        internal const string EnumFormat_D = "EnumFormat_D";
        internal const string EnumFormat_G = "EnumFormat_G";
        internal const string EnumFormat_X = "EnumFormat_X";
        internal const string Error = "Error";
        internal const string ExceptionDataRangeDiffColCount = "ExceptionDataRangeDiffColCount";
        internal const string ExceptionDataRangeDiffRowCount = "ExceptionDataRangeDiffRowCount";
        internal const string GeneralFormat_G = "GeneralFormat_G";
        internal const string GRID_IDM_CLEARDATA = "GRID_IDM_CLEARDATA";
        internal const string GRID_IDM_COPYINTERNAL = "GRID_IDM_COPYINTERNAL";
        internal const string GRID_IDM_CUTDATA = "GRID_IDM_CUTDATA";
        internal const string GRID_IDM_DRAGDROP_COPY = "GRID_IDM_DRAGDROP_COPY";
        internal const string GRID_IDM_DRAGDROP_MOVE = "GRID_IDM_DRAGDROP_MOVE";
        internal const string GRID_IDM_PASTEDATA = "GRID_IDM_PASTEDATA";
        internal const string GRID_IDM_PASTEDIFFRANGE = "GRID_IDM_PASTEDIFFRANGE";
        internal const string GRID_IDM_PASTINGDATA = "GRID_IDM_PASTINGDATA";
        internal const string GRID_IDM_REMOVECOLS = "GRID_IDM_REMOVECOLS";
        internal const string GRID_IDM_REMOVEROWS = "GRID_IDM_REMOVEROWS";
        internal const string GRID_IDM_RESIZECOLS = "GRID_IDM_RESIZECOLS";
        internal const string GRID_IDM_RESIZEROWS = "GRID_IDM_RESIZEROWS";
        internal const string GRID_IDS_COLOR_BACKGROUND = "GRID_IDS_COLOR_BACKGROUND";
        internal const string GRID_IDS_COLOR_DRAGGINGLINE = "GRID_IDS_COLOR_DRAGGINGLINE";
        internal const string GRID_IDS_COLOR_FIXEDLINES = "GRID_IDS_COLOR_FIXEDLINES";
        internal const string GRID_IDS_COLOR_GRIDLINES = "GRID_IDS_COLOR_GRIDLINES";
        internal const string GRID_IDS_COLOR_TRACKINGLINE = "GRID_IDS_COLOR_TRACKINGLINE";
        internal const string GRID_IDS_INVERTDRAWBORDER = "GRID_IDS_INVERTDRAWBORDER";
        internal const string GRID_IDS_INVERTNOBORDER = "GRID_IDS_INVERTNOBORDER";
        internal const string GRID_IDS_INVERTNORMAL = "GRID_IDS_INVERTNORMAL";
        internal const string GRID_IDS_INVERTTHICK = "GRID_IDS_INVERTTHICK";
        internal const string GRID_IDS_INVERTTHICKBORDER = "GRID_IDS_INVERTTHICKBORDER";
        internal const string GRID_IDS_OUTLINECURRENTCELL = "GRID_IDS_OUTLINECURRENTCELL";
        internal const string GridCheckBoxCellModel = "GridCheckBoxCellModel";
        internal const string GridCheckBoxCellModelDesc = "GridCheckBoxCellModelDesc";
        internal const string GridComboBoxCellModel = "GridComboBoxCellModel";
        internal const string GridComboBoxCellModelDesc = "GridComboBoxCellModelDesc";
        internal const string GridControlName = "GridControlName";
        internal const string GridCustomStyleProperty_CheckBoxState = "GridCustomStyleProperty_CheckBoxState";
        internal const string GridCustomStyleProperty_NumberFormatInfo = "GridCustomStyleProperty_NumberFormatInfo";
        internal const string GridCustomStyleProperty_NumericUpDown = "GridCustomStyleProperty_NumericUpDown";
        internal const string GridCustomStyleProperty_ParseInfo = "GridCustomStyleProperty_ParseInfo";
        internal const string GridCustomStyleProperty_Validation = "GridCustomStyleProperty_Validation";
        internal const string GridDesignerCodeGenFailed = "GridDesignerCodeGenFailed";
        internal const string GridDesignerGeneratedCode = "GridDesignerGeneratedCode";
        internal const string GridDesignerNoCode = "GridDesignerNoCode";
        internal const string GridDesignerNoSelection = "GridDesignerNoSelection";
        internal const string GridDesignerStateChangeFailed = "GridDesignerStateChangeFailed";
        internal const string GridDesignerTemplateExportFailed = "GridDesignerTemplateExportFailed";
        internal const string GridDesignerTemplateImportFailed = "GridDesignerTemplateImportFailed";
        internal const string GridDragButtonCellModel = "GridDragButtonCellModel";
        internal const string GridDragButtonCellModelDesc = "GridDragButtonCellModelDesc";
        internal const string GridDropDownCellModel = "GridDropDownCellModel";
        internal const string GridDropDownCellModelDesc = "GridDropDownCellModelDesc";
        internal const string GridDropDownColorUICellModel = "GridDropDownColorUICellModel";
        internal const string GridDropDownColorUICellModelDesc = "GridDropDownColorUICellModelDesc";
        internal const string GridDropDownGridCellModel = "GridDropDownGridCellModel";
        internal const string GridDropDownGridCellModelDesc = "GridDropDownGridCellModelDesc";
        internal const string GridDropDownHeaderCellModel = "GridDropDownHeaderCellModel";
        internal const string GridDropDownHeaderCellModelDesc = "GridDropDownHeaderCellModelDesc";
        internal const string GridDropDownMonthCalendarCellModel = "GridDropDownMonthCalendarCellModel";
        internal const string GridDropDownMonthCalendarCellModelDesc = "GridDropDownMonthCalendarCellModelDesc";
        internal const string GridDropDownRichTextBoxCellModel = "GridDropDownRichTextBoxCellModel";
        internal const string GridDropDownRichTextBoxCellModelDesc = "GridDropDownRichTextBoxCellModelDesc";
        internal const string GridHeaderCellModel = "GridHeaderCellModel";
        internal const string GridHeaderCellModelDesc = "GridHeaderCellModelDesc";
        internal const string GridNumericUpDownCellModel = "GridNumericUpDownCellModel";
        internal const string GridNumericUpDownCellModelDesc = "GridNumericUpDownCellModelDesc";
        internal const string GridPushButtonCellModel = "GridPushButtonCellModel";
        internal const string GridPushButtonCellModelDesc = "GridPushButtonCellModelDesc";
        internal const string GridStaticCellModel = "GridStaticCellModel";
        internal const string GridStaticCellModelDesc = "GridStaticCellModelDesc";
        internal const string GridStyleCategoryAlignment = "GridStyleCategoryAlignment";
        internal const string GridStyleCategoryAppearance = "GridStyleCategoryAppearance";
        internal const string GridStyleCategoryBehavior = "GridStyleCategoryBehavior";
        internal const string GridStyleCategoryDisplay = "GridStyleCategoryDisplay";
        internal const string GridStyleCategoryGraphics = "GridStyleCategoryGraphics";
        internal const string GridStyleCategoryStyle = "GridStyleCategoryStyle";
        internal const string GridStyleCategoryUser = "GridStyleCategoryUser";
        internal const string GridStyleCategoryValue = "GridStyleCategoryValue";
        internal const string GridTextBoxCellModel = "GridTextBoxCellModel";
        internal const string GridTextBoxCellModelDesc = "GridTextBoxCellModelDesc";
        internal const string InvalidOperation_GridCellNotInitialized = "InvalidOperation_GridCellNotInitialized";
        internal const string ModName = "ModName";
        internal const string NumberFormat_C = "NumberFormat_C";
        internal const string NumberFormat_D = "NumberFormat_D";
        internal const string NumberFormat_E = "NumberFormat_E";
        internal const string NumberFormat_F = "NumberFormat_F";
        internal const string NumberFormat_G = "NumberFormat_G";
        internal const string NumberFormat_N = "NumberFormat_N";
        internal const string NumberFormat_P = "NumberFormat_P";
        internal const string NumberFormat_R = "NumberFormat_R";
        internal const string NumberFormat_X = "NumberFormat_X";
        internal const string StyleCategoryAppearance = "StyleCategoryAppearance";
        internal const string StyleCategoryBehavior = "StyleCategoryBehavior";
        internal const string StyleCategoryStyle = "StyleCategoryStyle";
        internal const string StyleCategoryValue = "StyleCategoryValue";
        internal const string Test = "Test";
        internal const string TextParseFailedFormat = "TextParseFailedFormat";
        internal const string TopLeftBottomRight = "TopLeftBottomRight";
        internal const string Cannotchangepartofamergedcell = "Cannotchangepartofamergedcell";
        internal const string SpecifiedTextWasNotFound = "SpecifiedTextWasNotFound";
        internal const string SearchResults = "SearchResults";
        internal const string FindReachedTheStartingPointOfTheSearch="FindReachedTheStartingPointOfTheSearch";
        internal const string GridFindAndReplaceReplaceAll = "GridFindAndReplaceReplaceAll";
        internal const string GridFindAndReplaceReplaceWith="GridFindAndReplaceReplaceWith";
        internal const string GridFindAndReplaceSearchUp = "GridFindAndReplaceSearchUp";
        internal const string GridFindAndReplaceMatchCase = "GridFindAndReplaceMatchCase";
        internal const string GridFindAndReplaceFindWhat = "GridFindAndReplaceFindWhat";
        internal const string GridFindAndReplaceMatchWholeCell = "GridFindAndReplaceMatchWholeCell";
        internal const string Close = "Close";
        internal const string GridFindAndReplace = "GridFindAndReplace";
        internal const string GridFindAndReplaceFindNext="GridFindAndReplaceFindNext";
        internal const string DoYouWantToReplaceTheContentsOfTheDestinationCellsIfAny = "DoYouWantToReplaceTheContentsOfTheDestinationCellsIfAny";
        internal const string Request = "Request";
        internal const string UnabletoLoadImage = "UnabletoLoadImage";
        internal const string LoadFailed = "LoadFailed";
        internal const string AnErrorOccurredAttemptingToPreviewtheFiletoprint = "AnErrorOccurredAttemptingToPreviewtheFiletoprint";
        internal const string AnErrorOccurred = "AnErrorOccurred";
        internal const string FileSaved="FileSaved";
        internal const string UnabletoLoadtheSavedTemplate = "UnabletoLoadtheSavedTemplate";
        internal const string LoadFailure="LoadFailure";

        private SR()
        {
            this.resources = new ResourceManager(this.GetType());
        }

        // Methods
        private static SR GetLoader()
        {
            lock (typeof(SR))
            {
                if (SR.loader == null)
                {
                    SR.loader = new SR();
                }

                return SR.loader;
            }
        }

        static bool isGetStringError = false;
        //// Methods

        public static string GetString(CultureInfo culture, string name, params object[] args)
        {
            if (isGetStringError)
                return name;

            SR sr = SR.GetLoader();
            string value=string.Empty;

            if (sr == null)
            {
                return null;
            }

            try
            {
                if (LocalizationProvider.Provider != null)
                {
                    String result = string.Empty;

                    result = LocalizationProvider.Provider.GetLocalizedString(culture, name, args);

                    if (result != string.Empty)
                        return result;
                }

                if (name != null)
                    value = sr.resources.GetString(name, culture);
                if (value != null && args != null && args.Length > 0)
                {
                    return String.Format(value, args);
                }

                return value;
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.ToString());
                //TraceUtil.TraceExceptionCatched(ex);
                //if (!ExceptionManager.RaiseExceptionCatched(null, ex))
                //{
                //    throw;
                //}
                isGetStringError = true;
                return name;
            }
        }
        
        public static string GetString(string name)
        {
            return SR.GetString(null, name);
        }

        public static string GetString(string name, params object[] args)
        {
            return SR.GetString(null, name, args);
        }

        public static string GetString(CultureInfo culture, string name)
        {
            SR sr = SR.GetLoader();
            if (sr == null)
                return null;
            try
            {
                if (LocalizationProvider.Provider != null)
                {
                    String result = string.Empty;

                    result = LocalizationProvider.Provider.GetLocalizedString(culture, name, null);

                    if (result != string.Empty)
                        return result;
                }
                return sr.resources.GetString(name, culture);
            }
            catch
            {
                return name;
            }
        }

        public static object GetObject(CultureInfo culture, string name)
        {
            SR sr = SR.GetLoader();
            if (sr == null)
            {
                return null;
            }

            return sr.resources.GetObject(name, culture);
        }

        public static object GetObject(string name)
        {
            return SR.GetObject(null, name);
        }
        
        public static bool GetBoolean(CultureInfo culture, string name)
        {
            bool value;
            SR sr = SR.GetLoader();
            object obj;
            value = false;
            if (sr != null)
            {
                obj = sr.resources.GetObject(name, culture);
                if (obj is System.Boolean)
                {
                    value = (bool)obj;
                }
            }

            return value;
        }
        
        public static bool GetBoolean(string name)
        {
            return SR.GetBoolean(name);
        }
        
        public static byte GetByte(CultureInfo culture, string name)
        {
            byte value;
            SR sr = SR.GetLoader();
            object obj;
            value = (byte)0;
            if (sr != null)
            {
                obj = sr.resources.GetObject(name, culture);
                if (obj is System.Byte)
                {
                    value = (byte)obj;
                }
            }

            return value;
        }
        
        public static byte GetByte(string name)
        {
            return SR.GetByte(null, name);
        }
        
        public static char GetChar(CultureInfo culture, string name)
        {
            char value;
            SR sr = SR.GetLoader();
            object obj;
            value = (char)0;
            if (sr != null)
            {
                obj = sr.resources.GetObject(name, culture);
                if (obj is System.Char)
                {
                    value = (char)obj;
                }
            }

            return value;
        }
        
        public static char GetChar(string name)
        {
            return SR.GetChar(null, name);
        }
        
        public static double GetDouble(CultureInfo culture, string name)
        {
            double value;
            SR sr = SR.GetLoader();
            object obj;
            value = 0.0;
            if (sr != null)
            {
                obj = sr.resources.GetObject(name, culture);
                if (obj is System.Double)
                {
                    value = (double)obj;
                }
            }

            return value;
        }

        public static double GetDouble(string name)
        {
            return SR.GetDouble(null, name);
        }

        public static float GetFloat(CultureInfo culture, string name)
        {
            float value;
            SR sr = SR.GetLoader();
            object obj;
            value = 0.0f;
            if (sr != null)
            {
                obj = sr.resources.GetObject(name, culture);
                if (obj is System.Single)
                {
                    value = (float)obj;
                }
            }

            return value;
        }
        
        public static float GetFloat(string name)
        {
            return SR.GetFloat(null, name);
        }
        
        public static int GetInt(string name)
        {
            return SR.GetInt(null, name);
        }
        
        public static int GetInt(CultureInfo culture, string name)
        {
            int value;
            SR sr = SR.GetLoader();
            object obj;
            value = 0;
            if (sr != null)
            {
                obj = sr.resources.GetObject(name, culture);
                if (obj is System.Int32)
                {
                    value = (int)obj;
                }
            }

            return value;
        }
        
        public static long GetLong(string name)
        {
            return SR.GetLong(null, name);
        }
        
        public static long GetLong(CultureInfo culture, string name)
        {
            Int64 value;
            SR sr = SR.GetLoader();
            object obj;
            value = (Int64)0;
            if (sr != null)
            {
                obj = sr.resources.GetObject(name, culture);
                if (obj is System.Int64)
                {
                    value = (Int64)obj;
                }
            }
            
            return value;
        }

        public static short GetShort(CultureInfo culture, string name)
        {
            short value;
            SR sr = SR.GetLoader();
            object obj;
            value = (short)0;
            if (sr != null)
            {
                obj = sr.resources.GetObject(name, culture);
                if (obj is System.Int16)
                {
                    value = (short)obj;
                }
            }

            return value;
        }
        
        public static short GetShort(string name)
        {
            return SR.GetShort(null, name);
        }
    }

    /// <summary>
    /// Specifies the category in which the property or event will be displayed in a visual designer.
    /// </summary>
    /// <remarks>
    /// This is a localized version of CategoryAttribute. The localized string will be loaded from the 
    /// assembly manifest Syncfusion.Windows.Forms.Grid.SR.resources
    /// </remarks>
    [AttributeUsage(AttributeTargets.All, AllowMultiple = false, Inherited = true)]
    sealed class SRCategoryAttribute : CategoryAttribute
    {
        public SRCategoryAttribute(string category)
            : base(category)
        {
        }

        protected override string GetLocalizedString(string value)
        {
            return SR.GetString(value);
        }
    }

    /// <summary>
    /// Specifies a description for a property or event.
    /// </summary>
    /// <remarks>
    /// This is a localized version of DescriptionAttribute. The localized string will be loaded from the 
    /// assembly manifest Syncfusion.Windows.Forms.Grid.SR.resources
    /// </remarks>
    [AttributeUsage(AttributeTargets.All, AllowMultiple = false, Inherited = true)]
    sealed class SRDescriptionAttribute : DescriptionAttribute
    {
        private bool replaced = false;

        public SRDescriptionAttribute(string description)
            : base(description)
        {
        }

        public override string Description
        {
            get
            {
                if (!this.replaced)
                {
                    this.replaced = true;
                    this.DescriptionValue = SR.GetString(base.Description);
                }

                return base.Description;
            }
        }
    }
    public sealed class GridResourceIdentifiers
    {
        #region Strings Constants

        public const string FilterBarAll = "FilterBarAll";
        public const string BitVectorFull = "BitVectorFull";
        public const string ColorEditorPaletteTab = "ColorEditorPaletteTab";
        public const string ColorEditorStandardTab = "ColorEditorStandardTab";
        public const string ColorEditorSystemTab = "ColorEditorSystemTab";
        public const string CommandAddCoveredRanges = "CommandAddCoveredRanges";
        public const string CommandChangeCells = "CommandChangeCells";
        public const string CommandColumnWidth = "CommandColumnWidth";
        public const string CommandDefaultSizeColumn = "CommandDefaultSizeColumn";
        public const string CommandDefaultSizeRow = "CommandDefaultSizeRow";
        public const string CommandFixedCountColumn = "CommandFixedCountColumn";
        public const string CommandFixedCountRow = "CommandFixedCountRow";
        public const string CommandHeaderCountColumn = "CommandHeaderCountColumn";
        public const string CommandHeaderCountRow = "CommandHeaderCountRow";
        public const string CommandHideColumn = "CommandHideColumn";
        public const string CommandHideRow = "CommandHideRow";
        public const string CommandInsertColumn = "CommandInsertColumn";
        public const string CommandInsertRow = "CommandInsertRow";
        public const string CommandMoveColumn = "CommandMoveColumn";
        public const string CommandMoveRow = "CommandMoveRow";
        public const string CommandRemoveColumn = "CommandRemoveColumn";
        public const string CommandRemoveCoveredRanges = "CommandRemoveCoveredRanges";
        public const string CommandRemoveRow = "CommandRemoveRow";
        public const string CommandRowHeight = "CommandRowHeight";
        public const string DateTimeFormat_D = "DateTimeFormat_D";
        public const string DateTimeFormat_dd = "DateTimeFormat_dd";
        public const string DateTimeFormat_F = "DateTimeFormat_F";
        public const string DateTimeFormat_ff = "DateTimeFormat_ff";
        public const string DateTimeFormat_G = "DateTimeFormat_G";
        public const string DateTimeFormat_gg = "DateTimeFormat_gg";
        public const string DateTimeFormat_M = "DateTimeFormat_M";
        public const string DateTimeFormat_R = "DateTimeFormat_R";
        public const string DateTimeFormat_ss = "DateTimeFormat_ss";
        public const string DateTimeFormat_T = "DateTimeFormat_T";
        public const string DateTimeFormat_tt = "DateTimeFormat_tt";
        public const string DateTimeFormat_U = "DateTimeFormat_U";
        public const string DateTimeFormat_uu = "DateTimeFormat_uu";
        public const string DateTimeFormat_Y = "DateTimeFormat_Y";
        public const string DescriptionChangeCells = "DescriptionChangeCells";
        public const string DescriptionInsertColumn = "DescriptionInsertColumn";
        public const string DescriptionInsertRow = "DescriptionInsertRow";
        public const string DescriptionMoveColumn = "DescriptionMoveColumn";
        public const string DescriptionMoveRow = "DescriptionMoveRow";
        public const string DescriptionRemoveColumn = "DescriptionRemoveColumn";
        public const string DescriptionRemoveRow = "DescriptionRemoveRow";
        public const string EnumFormat_D = "EnumFormat_D";
        public const string EnumFormat_G = "EnumFormat_G";
        public const string EnumFormat_X = "EnumFormat_X";
        public const string Error = "Error";
        public const string ExceptionDataRangeDiffColCount = "ExceptionDataRangeDiffColCount";
        public const string ExceptionDataRangeDiffRowCount = "ExceptionDataRangeDiffRowCount";
        public const string GeneralFormat_G = "GeneralFormat_G";
        public const string GRID_IDM_CLEARDATA = "GRID_IDM_CLEARDATA";
        public const string GRID_IDM_COPYINTERNAL = "GRID_IDM_COPYINTERNAL";
        public const string GRID_IDM_CUTDATA = "GRID_IDM_CUTDATA";
        public const string GRID_IDM_DRAGDROP_COPY = "GRID_IDM_DRAGDROP_COPY";
        public const string GRID_IDM_DRAGDROP_MOVE = "GRID_IDM_DRAGDROP_MOVE";
        public const string GRID_IDM_PASTEDATA = "GRID_IDM_PASTEDATA";
        public const string GRID_IDM_PASTEDIFFRANGE = "GRID_IDM_PASTEDIFFRANGE";
        public const string GRID_IDM_PASTINGDATA = "GRID_IDM_PASTINGDATA";
        public const string GRID_IDM_REMOVECOLS = "GRID_IDM_REMOVECOLS";
        public const string GRID_IDM_REMOVEROWS = "GRID_IDM_REMOVEROWS";
        public const string GRID_IDM_RESIZECOLS = "GRID_IDM_RESIZECOLS";
        public const string GRID_IDM_RESIZEROWS = "GRID_IDM_RESIZEROWS";
        public const string GRID_IDS_COLOR_BACKGROUND = "GRID_IDS_COLOR_BACKGROUND";
        public const string GRID_IDS_COLOR_DRAGGINGLINE = "GRID_IDS_COLOR_DRAGGINGLINE";
        public const string GRID_IDS_COLOR_FIXEDLINES = "GRID_IDS_COLOR_FIXEDLINES";
        public const string GRID_IDS_COLOR_GRIDLINES = "GRID_IDS_COLOR_GRIDLINES";
        public const string GRID_IDS_COLOR_TRACKINGLINE = "GRID_IDS_COLOR_TRACKINGLINE";
        public const string GRID_IDS_INVERTDRAWBORDER = "GRID_IDS_INVERTDRAWBORDER";
        public const string GRID_IDS_INVERTNOBORDER = "GRID_IDS_INVERTNOBORDER";
        public const string GRID_IDS_INVERTNORMAL = "GRID_IDS_INVERTNORMAL";
        public const string GRID_IDS_INVERTTHICK = "GRID_IDS_INVERTTHICK";
        public const string GRID_IDS_INVERTTHICKBORDER = "GRID_IDS_INVERTTHICKBORDER";
        public const string GRID_IDS_OUTLINECURRENTCELL = "GRID_IDS_OUTLINECURRENTCELL";
        public const string GridCheckBoxCellModel = "GridCheckBoxCellModel";
        public const string GridCheckBoxCellModelDesc = "GridCheckBoxCellModelDesc";
        public const string GridComboBoxCellModel = "GridComboBoxCellModel";
        public const string GridComboBoxCellModelDesc = "GridComboBoxCellModelDesc";
        public const string GridControlName = "GridControlName";
        public const string GridCustomStyleProperty_CheckBoxState = "GridCustomStyleProperty_CheckBoxState";
        public const string GridCustomStyleProperty_NumberFormatInfo = "GridCustomStyleProperty_NumberFormatInfo";
        public const string GridCustomStyleProperty_NumericUpDown = "GridCustomStyleProperty_NumericUpDown";
        public const string GridCustomStyleProperty_ParseInfo = "GridCustomStyleProperty_ParseInfo";
        public const string GridCustomStyleProperty_Validation = "GridCustomStyleProperty_Validation";
        public const string GridDesignerCodeGenFailed = "GridDesignerCodeGenFailed";
        public const string GridDesignerGeneratedCode = "GridDesignerGeneratedCode";
        public const string GridDesignerNoCode = "GridDesignerNoCode";
        public const string GridDesignerNoSelection = "GridDesignerNoSelection";
        public const string GridDesignerStateChangeFailed = "GridDesignerStateChangeFailed";
        public const string GridDesignerTemplateExportFailed = "GridDesignerTemplateExportFailed";
        public const string GridDesignerTemplateImportFailed = "GridDesignerTemplateImportFailed";
        public const string GridDragButtonCellModel = "GridDragButtonCellModel";
        public const string GridDragButtonCellModelDesc = "GridDragButtonCellModelDesc";
        public const string GridDropDownCellModel = "GridDropDownCellModel";
        public const string GridDropDownCellModelDesc = "GridDropDownCellModelDesc";
        public const string GridDropDownColorUICellModel = "GridDropDownColorUICellModel";
        public const string GridDropDownColorUICellModelDesc = "GridDropDownColorUICellModelDesc";
        public const string GridDropDownGridCellModel = "GridDropDownGridCellModel";
        public const string GridDropDownGridCellModelDesc = "GridDropDownGridCellModelDesc";
        public const string GridDropDownHeaderCellModel = "GridDropDownHeaderCellModel";
        public const string GridDropDownHeaderCellModelDesc = "GridDropDownHeaderCellModelDesc";
        public const string GridDropDownMonthCalendarCellModel = "GridDropDownMonthCalendarCellModel";
        public const string GridDropDownMonthCalendarCellModelDesc = "GridDropDownMonthCalendarCellModelDesc";
        public const string GridDropDownRichTextBoxCellModel = "GridDropDownRichTextBoxCellModel";
        public const string GridDropDownRichTextBoxCellModelDesc = "GridDropDownRichTextBoxCellModelDesc";
        public const string GridHeaderCellModel = "GridHeaderCellModel";
        public const string GridHeaderCellModelDesc = "GridHeaderCellModelDesc";
        public const string GridNumericUpDownCellModel = "GridNumericUpDownCellModel";
        public const string GridNumericUpDownCellModelDesc = "GridNumericUpDownCellModelDesc";
        public const string GridPushButtonCellModel = "GridPushButtonCellModel";
        public const string GridPushButtonCellModelDesc = "GridPushButtonCellModelDesc";
        public const string GridStaticCellModel = "GridStaticCellModel";
        public const string GridStaticCellModelDesc = "GridStaticCellModelDesc";
        public const string GridStyleCategoryAlignment = "GridStyleCategoryAlignment";
        public const string GridStyleCategoryAppearance = "GridStyleCategoryAppearance";
        public const string GridStyleCategoryBehavior = "GridStyleCategoryBehavior";
        public const string GridStyleCategoryDisplay = "GridStyleCategoryDisplay";
        public const string GridStyleCategoryGraphics = "GridStyleCategoryGraphics";
        public const string GridStyleCategoryStyle = "GridStyleCategoryStyle";
        public const string GridStyleCategoryUser = "GridStyleCategoryUser";
        public const string GridStyleCategoryValue = "GridStyleCategoryValue";
        public const string GridTextBoxCellModel = "GridTextBoxCellModel";
        public const string GridTextBoxCellModelDesc = "GridTextBoxCellModelDesc";
        public const string InvalidOperation_GridCellNotInitialized = "InvalidOperation_GridCellNotInitialized";
        public const string ModName = "ModName";
        public const string NumberFormat_C = "NumberFormat_C";
        public const string NumberFormat_D = "NumberFormat_D";
        public const string NumberFormat_E = "NumberFormat_E";
        public const string NumberFormat_F = "NumberFormat_F";
        public const string NumberFormat_G = "NumberFormat_G";
        public const string NumberFormat_N = "NumberFormat_N";
        public const string NumberFormat_P = "NumberFormat_P";
        public const string NumberFormat_R = "NumberFormat_R";
        public const string NumberFormat_X = "NumberFormat_X";
        public const string StyleCategoryAppearance = "StyleCategoryAppearance";
        public const string StyleCategoryBehavior = "StyleCategoryBehavior";
        public const string StyleCategoryStyle = "StyleCategoryStyle";
        public const string StyleCategoryValue = "StyleCategoryValue";
        public const string Test = "Test";
        public const string TextParseFailedFormat = "TextParseFailedFormat";
        public const string TopLeftBottomRight = "TopLeftBottomRight";
        public const string Cannotchangepartofamergedcell = "Cannotchangepartofamergedcell";
        public const string SpecifiedTextWasNotFound = "SpecifiedTextWasNotFound";
        public const string SearchResults = "SearchResults";
        public const string FindReachedTheStartingPointOfTheSearch = "FindReachedTheStartingPointOfTheSearch";
        public const string GridFindAndReplaceReplaceAll="GridFindAndReplaceReplaceAll";
        public const string GridFindAndReplaceReplaceWith = "GridFindAndReplaceReplaceWith";
        public const string GridFindAndReplaceSearchUp = "GridFindAndReplaceSearchUp";
        public const string GridFindAndReplaceMatchCase = "GridFindAndReplaceMatchCase";
        public const string GridFindAndReplaceFindWhat = "GridFindAndReplaceFindWhat";
        public const string GridFindAndReplaceMatchWholeCell="GridFindAndReplaceMatchWholeCell";
        public const string Close = "Close";
        public const string GridFindAndReplace="GridFindAndReplace";
        public const string GridFindAndReplaceFindNext = "GridFindAndReplaceFindNext";
        public const string DoYouWantToReplaceTheContentsOfTheDestinationCellsIfAny = "DoYouWantToReplaceTheContentsOfTheDestinationCellsIfAny";
        public const string Request="Request";
        public const string UnabletoLoadImage = "UnabletoLoadImage";
        public const string LoadFailed = "LoadFailed";
        public const string AnErrorOccurredAttemptingToPreviewtheFiletoprint = "AnErrorOccurredAttemptingToPreviewtheFiletoprint";
        public const string AnErrorOccurred = "AnErrorOccurred";
        public const string FileSaved = "FileSaved";
        public const string UnabletoLoadtheSavedTemplate="UnabletoLoadtheSavedTemplate";
        public const string LoadFailure = "LoadFailure";
        #endregion
    }
} // end of namespace Syncfusion.Windows.Forms.Grid
