#region Copyright Syncfusion Inc. 2001 - 2006
//
//  Copyright Syncfusion Inc. 2001 - 2006. All rights reserved.
//
//  Use of this code is subject to the terms of our license.
//  A copy of the current license can be obtained at any time by e-mailing
//  licensing@syncfusion.com. Re-distribution in any form is strictly
//  prohibited. Any infringement will be prosecuted under applicable laws. 
//
#endregion

using System;
using System.ComponentModel;
using System.Drawing;
using System.Windows.Forms;

namespace Syncfusion.Windows.Forms
{
	/// <summary>
	/// Used by the <see cref="Syncfusion.Windows.Forms.WorksheetModel"/> to allow its content to create a control if it implements this interface.
	/// </summary>
	public interface ICreateControl
	{
		/// <summary>
		/// Creates a new <see cref="System.Windows.Forms.Control"/>.
		/// </summary>
		/// <returns>A new <see cref="System.Windows.Forms.Control"/> instance.</returns>
		Control CreateControl();
	}
}
