﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing.Drawing2D;
using System.Drawing;

namespace Syncfusion.Windows.Forms
{
    class MetroTabsRenderer : TabsRendererBase
    {
          #region Class constants
        private const int c_defaultOverlapWidth = 16;
        private const int c_cornerCut = 2;
        #endregion

        #region Class members
  
        #endregion

        #region Class initialize

        public MetroTabsRenderer(InternalTab parent)
            : base( parent )
        {
           }

        #endregion

        #region Class properties
        /// </override>
        protected override Font ActiveTabFont
        {
            get
            {
                return new Font( base.ActiveTabFont, FontStyle.Bold );
            }
        }

        /// </override>
        protected override Color ForeColor
        {
            get
            {
                if( this.Parent != null )
                {
                    if (this.Parent.Pushed)
                        return Color.White;
                    else
                        return Color.Black;
                }
                else
                {
                    return base.ForeColor;
                }
            }
        }

        /// </override>

        #endregion

        private Color metroHighlightColor = ColorTranslator.FromHtml("#119EDA");

        public Color MetroHighlightColor
        {
            get { return metroHighlightColor; }
            set { metroHighlightColor = value; }
        }

        private Color metroNormalColor = ColorTranslator.FromHtml("#EBEBEB");

        public Color MetroNormalColor
        {
            get { return metroNormalColor; }
            set { metroNormalColor = value; }
        }





        #region Class overrides

        /// </override>
        public override void DrawBackground( Graphics g )
        {
            Rectangle rectFill = this.Bounds;

        
            if( this.Parent.Pushed )
            {
                if( this.Parent.Hovered )
                {
                }

                using (Brush br = new SolidBrush(MetroHighlightColor))
                {                   
                    g.FillRectangle ( br, rectFill );
                }

            }
            else
            {

                 using (Brush br = new SolidBrush(MetroNormalColor))
                {
                    g.FillRectangle( br, rectFill);
                }
           }
        }


        
        /// </override>
        public override void DrawBorders(Graphics g)
        {
        
        }

        protected override void DrawTextAndImage(Graphics g, Rectangle rectTextAndImage)
        {
            base.DrawTextAndImage(g, rectTextAndImage);
        }

        /// </override>
        public override Size GetItemPreferredSize()
        {
            Size size = base.GetItemPreferredSize();
            size.Width += c_defaultOverlapWidth;
            return size;
        }

        /// </override>
        public override int GetOverlappedWidth()
        {
            return 0;
        }
        #endregion

  
    }
}
