#Region "Copyright Syncfusion Inc. 2001 - 2006"
'
'  Copyright Syncfusion Inc. 2001 - 2006. All rights reserved.
'
'  Use of this code is subject to the terms of our license.
'  A copy of the current license can be obtained at any time by e-mailing
'  licensing@syncfusion.com. Any infringement will be prosecuted under
'  applicable laws. 
'
#End Region

Imports System
Imports System.Drawing
Imports System.Collections
Imports System.ComponentModel
Imports System.Windows.Forms

Imports Syncfusion.Windows.Forms.Grid
Imports Syncfusion.Drawing
Imports Syncfusion.Styles


'/ <summary>
'/ Summary description for GridDialog.
'/ </summary>

Public Class GridDialog
    Inherits Syncfusion.Windows.Forms.MetroForm
   Private model As GridModel
   Private grid1 As SampleGrid
   Private vScrollBar1 As System.Windows.Forms.VScrollBar
   Private hScrollBar1 As System.Windows.Forms.HScrollBar
   '/ <summary>
   '/ Required designer variable.
   '/ </summary>
   Private components As System.ComponentModel.Container = Nothing
   
   
   Public Sub New()
      '
      ' Required for Windows Form Designer support
      '
      model = New GridModel()
      SampleGrid.SetupGridModel(model)
      InitializeComponent()
      
      grid1.Model = model
      
      Dim transparent As Boolean = True
      Dim alpablend As Boolean = False
      
      If transparent Then
         ' Transparent
         If alpablend Then
            ' I can either do alphablending
            grid1.SupportsTransparentBackColor = True
            grid1.TableStyle.Interior = New BrushInfo(Color.FromArgb(50, 204, 212, 230))
         Else
            ' or tell grid not to draw background of cells
            grid1.TransparentBackground = True
         End If
         
         ' (grid.TransparentBackground completely disables background drawing for all cells
         ' whereas SupportsTransparentBackColor = true  together with TransparentBackground
         ' lets me do alphablending).
         Dim type As Type = GetType(Bitmap)
            Dim stream As System.IO.Stream = GetType(SampleGrid).Module.Assembly.GetManifestResourceStream((ApplicationMain.manifestNamespace + "logo_800_edf0f7.jpg"))
         Dim bm As New Bitmap(stream)
         grid1.BackgroundImage = bm
      End If
      
      ' attach my own scrollbars to grid
      grid1.HScrollBehavior = GridScrollbarMode.Shared
      grid1.VScrollBehavior = GridScrollbarMode.Shared
      grid1.UseSharedScrollBars = True
      grid1.VScrollBar.InnerScrollBar = Me.vScrollBar1
      grid1.HScrollBar.InnerScrollBar = Me.hScrollBar1
      grid1.VerticalThumbTrack = True
      grid1.HorizontalThumbTrack = True
   End Sub 'New
    
   ' Have grid not occupy the whole client rectangle
   '			Rectangle r = grid1.ClientRectangle;
   '			r.Inflate(-20, -20);
   '			grid1.GridBounds = r;
   
   '/ <summary>
   '/ Clean up any resources being used.
   '/ </summary>
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub 'Dispose


    '/ <summary>
    '/ Required method for Designer support - do not modify
    '/ the contents of this method with the code editor.
    '/ </summary>
    Private Sub InitializeComponent()
        Me.grid1 = New SampleGrid()
        Me.hScrollBar1 = New System.Windows.Forms.HScrollBar()
        Me.vScrollBar1 = New System.Windows.Forms.VScrollBar()
        CType(Me.grid1, System.ComponentModel.ISupportInitialize).BeginInit()
        Me.SuspendLayout()
        ' 
        ' grid1
        ' 
        Me.grid1.Location = New System.Drawing.Point(20, 16)
        Me.grid1.Name = "grid1"
        Me.grid1.Size = New System.Drawing.Size(536, 288)
        Me.grid1.TabIndex = 0
        Me.grid1.Text = "grid1"
        Me.grid1.Anchor = AnchorStyles.Top Or AnchorStyles.Bottom Or AnchorStyles.Left Or AnchorStyles.Right
        ' 
        ' hScrollBar1
        ' 
        Me.hScrollBar1.BackColor = System.Drawing.Color.FromArgb(CType(252, System.Byte), CType(172, System.Byte), CType(38, System.Byte))
        Me.hScrollBar1.Location = New System.Drawing.Point(68, 336)
        Me.hScrollBar1.Size = New System.Drawing.Size(464, 16)
        Me.hScrollBar1.Name = "hScrollBar1"
        Me.hScrollBar1.TabIndex = 1
        Me.hScrollBar1.Anchor = AnchorStyles.Top Or AnchorStyles.Bottom Or AnchorStyles.Right
        ' 
        ' vScrollBar1
        ' 
        Me.vScrollBar1.BackColor = System.Drawing.Color.FromArgb(CType(252, System.Byte), CType(172, System.Byte), CType(38, System.Byte))
        Me.vScrollBar1.Location = New System.Drawing.Point(584, 56)
        Me.vScrollBar1.Size = New System.Drawing.Size(16, 224)
        Me.vScrollBar1.Name = "vScrollBar1"
        Me.vScrollBar1.TabIndex = 2
        Me.grid1.Anchor = AnchorStyles.Bottom Or AnchorStyles.Left Or AnchorStyles.Right
        ' 
        ' GridDialog
        ' 
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(616, 365)
        Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.vScrollBar1, Me.hScrollBar1, Me.grid1})
        Me.Name = "GridDialog"
        Me.Text = "GridDialog"
        Me.TransparencyKey = System.Drawing.SystemColors.Desktop
        CType(Me.grid1, System.ComponentModel.ISupportInitialize).EndInit()
        Me.ResumeLayout(False)
    End Sub 'InitializeComponent 
End Class 'GridDialog