#Region "Copyright Syncfusion Inc. 2001 - 2006"
'
'  Copyright Syncfusion Inc. 2001 - 2006. All rights reserved.
'
'  Use of this code is subject to the terms of our license.
'  A copy of the current license can be obtained at any time by e-mailing
'  licensing@syncfusion.com. Any infringement will be prosecuted under
'  applicable laws. 
'
#End Region

Imports System
Imports System.Drawing
Imports System.Collections
Imports System.ComponentModel
Imports System.Diagnostics
Imports System.Windows.Forms
Imports System.Data
Imports System.Reflection

Imports Syncfusion.Windows.Forms.Grid


'/ <summary>
'/    GridFrame is a MDI Child window that hosts the SampleGrid control.
'/ </summary>

Public Class GridFrame
    Inherits Syncfusion.Windows.Forms.MetroForm
   '/ <summary>
   '/    Required designer variable.
   '/ </summary>
   Private components As System.ComponentModel.Container
   Private grid1 As SampleGrid
   Private model As GridModel
   
   
   Public Sub New()
        model = New GridModel()
        SampleGrid.SetupGridModel(model)
        InitializeComponent()
        AddHandler grid1.Model.SelectionChanging, AddressOf grid1_SelectionChanging

        Me.grid1.Model = model
        Me.grid1.CurrentCell.MoveTo(1, 1)
   End Sub 'New
   
   
   Public Sub New(model As GridModel)
      Me.model = model
        SampleGrid.SetupGridModel(Me.model)
        InitializeComponent()
        AddHandler grid1.Model.SelectionChanging, AddressOf grid1_SelectionChanging
        Me.grid1.CurrentCell.MoveTo(1, 1)
   End Sub 'New
   
   
   '/ <summary>
   '/    Clean up any resources being used.
   '/ </summary>
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub 'Dispose


    '/ <summary>
    '/    Required method for Designer support - do not modify
    '/    the contents of this method with the code editor.
    '/ </summary>
    Private Sub InitializeComponent()
        Dim GridCellInfo1 As Syncfusion.Windows.Forms.Grid.GridCellInfo = New Syncfusion.Windows.Forms.Grid.GridCellInfo()
        Dim GridCellInfo2 As Syncfusion.Windows.Forms.Grid.GridCellInfo = New Syncfusion.Windows.Forms.Grid.GridCellInfo()
        Me.grid1 = New Syncfusion.Samples.GridPad.SampleGrid()
        Me.SuspendLayout()
        '
        'grid1
        '
        Me.grid1.AllowDragSelectedCols = True
        Me.grid1.AllowDragSelectedRows = True
        Me.grid1.BackColor = System.Drawing.Color.White
        Me.grid1.ColCount = 0
        Me.grid1.DefaultColWidth = 0
        Me.grid1.DefaultGridBorderStyle = Syncfusion.Windows.Forms.Grid.GridBorderStyle.Solid
        Me.grid1.DefaultRowHeight = 0
        Me.grid1.Dock = System.Windows.Forms.DockStyle.Fill
        Me.grid1.ExcelLikeCurrentCell = True
        Me.grid1.ExcelLikeSelectionFrame = True
        Me.grid1.Font = New System.Drawing.Font("Verdana", 8.25!)
        Me.grid1.ForeColor = System.Drawing.SystemColors.WindowText
        GridCellInfo1.Col = -1
        GridCellInfo1.Row = -1
        GridCellInfo1.StyleInfo.Font.Bold = False
        GridCellInfo1.StyleInfo.Font.Facename = "Verdana"
        GridCellInfo1.StyleInfo.Font.Italic = False
        GridCellInfo1.StyleInfo.Font.Size = 8.25!
        GridCellInfo1.StyleInfo.Font.Strikeout = False
        GridCellInfo1.StyleInfo.Font.Underline = False
        GridCellInfo1.StyleInfo.Font.Unit = System.Drawing.GraphicsUnit.Point
        GridCellInfo1.StyleInfo.TextColor = System.Drawing.Color.MidnightBlue
        GridCellInfo2.Col = -1
        GridCellInfo2.Row = -1
        GridCellInfo2.StyleInfo.Font.Facename = "Verdana"
        GridCellInfo2.StyleInfo.TextColor = System.Drawing.Color.MidnightBlue
        Me.grid1.GridCells.AddRange(New Syncfusion.Windows.Forms.Grid.GridCellInfo() {GridCellInfo1, GridCellInfo2})
        Me.grid1.GridVisualStyles = Syncfusion.Windows.Forms.GridVisualStyles.Metro
        Me.grid1.HorizontalScrollTips = True
        Me.grid1.HorizontalThumbTrack = True
        Me.grid1.Location = New System.Drawing.Point(0, 0)
        Me.grid1.Name = "grid1"
        Me.grid1.Properties.GridLineColor = System.Drawing.Color.FromArgb(CType(CType(208, Byte), Integer), CType(CType(215, Byte), Integer), CType(CType(229, Byte), Integer))
        Me.grid1.RowCount = 0
        Me.grid1.Size = Me.ClientSize
        Me.grid1.SmartSizeBox = False
        Me.grid1.TabIndex = 1
        Me.grid1.ThemesEnabled = True
        Me.grid1.VerticalScrollTips = True
        '
        'GridFrame
        '
        Me.CausesValidation = False
        Me.ClientSize = New System.Drawing.Size(352, 333)
        Me.Controls.Add(Me.grid1)
        Me.Name = "GridFrame"
        Me.ResumeLayout(False)

    End Sub 'InitializeComponent


    '/ <summary>
    '/ SelectionChanging event handler for grid.
    '/ </summary>
    '/ <model name="sender"></model>
    '/ <model name="e"></model>
    Public Sub grid1_SelectionChanging(ByVal sender As Object, ByVal e As GridSelectionChangingEventArgs)
        If e.Cancel Then
            Return
        End If
    End Sub 'grid1_SelectionChanging
End Class 'GridFrame