#Region "Copyright Syncfusion Inc. 2001 - 2006"
'
'  Copyright Syncfusion Inc. 2001 - 2006. All rights reserved.
'
'  Use of this code is subject to the terms of our license.
'  A copy of the current license can be obtained at any time by e-mailing
'  licensing@syncfusion.com. Any infringement will be prosecuted under
'  applicable laws. 
'
#End Region

Imports System
Imports System.Drawing
Imports System.Collections
Imports System.ComponentModel
Imports System.Windows.Forms
Imports System.IO
Imports System.Xml
Imports System.Reflection
Imports System.Diagnostics
Imports System.Resources
Imports Syncfusion.Windows.Forms.InternalMenus


'/ <summary>
'/    Summary description for MainFrame.
'/ </summary>

Public Class MainWindow
    Inherits Syncfusion.Windows.Forms.MetroForm
   '/ <summary>
   '/    Required designer variable.
   '/ </summary>
   Private components As System.ComponentModel.Container
   Protected lastfiles As MenuItem
   Public BufferOpenMenuItems As New ArrayList()
   Public statusBar As New StatusBar()
   Public statusBarPanel As New StatusBarPanel()
   Private statusBarPanel1 As New StatusBarPanel()
   Private statusBarPanel2 As New StatusBarPanel()
    Private menuFactory As MenuFactory

   
   
   Public Sub New()
      InitializeComponent()
        Me.Size = New System.Drawing.Size(300, 300)
        Me.Text = "Grid Pad Demo"
        Try
            Dim ico As New System.Drawing.Icon(GetIconFile("common\Images\Grid\Icon\sfgrid.ico"))
            Me.Icon = ico
        Catch
        End Try
        Try
            InitializeMenu()
            StandardStatusBar(Nothing, Nothing)
            statusBarPanel.BorderStyle = StatusBarPanelBorderStyle.None
            statusBarPanel.Width = 500
            statusBarPanel.AutoSize = StatusBarPanelAutoSize.Spring

            statusBarPanel1.BorderStyle = StatusBarPanelBorderStyle.Sunken
            statusBarPanel1.Width = 50
            statusBarPanel1.AutoSize = StatusBarPanelAutoSize.None

            statusBarPanel2.BorderStyle = StatusBarPanelBorderStyle.Sunken
            statusBarPanel2.Width = 50
            statusBarPanel2.AutoSize = StatusBarPanelAutoSize.None
            statusBar.ShowPanels = True
            statusBar.Panels.Add(statusBarPanel)
            statusBar.Panels.Add(statusBarPanel1)
            statusBar.Panels.Add(statusBarPanel2)

            Me.IsMdiContainer = True
            Anchor = Not AnchorStyles.None
            AddHandler MenuComplete, AddressOf StandardStatusBar

            ' set the old form start position
            Me.Size = New System.Drawing.Size(640, 480)

            Me.Controls.Add(statusBar)

        Catch
        End Try
    End Sub 'New

    Private Function GetIconFile(ByVal bitmapName As String) As String
        For n As Integer = 0 To 9
            If System.IO.File.Exists(bitmapName) Then
                Return bitmapName
            End If

            bitmapName = "..\" & bitmapName
        Next n

        Return bitmapName
    End Function
    Private Function InitializeMenu() As Boolean
        Try
            Dim maintoolbarResource As String = ApplicationMain.manifestNamespace & "DefaultToolbarItems.xml"
            Dim menuResource As String = ApplicationMain.manifestNamespace & "DefaultMenuItems.xml"
            Dim ft As FactoryType
#If SyncfusionFramework2_0 Then
            ft = FactoryType.WhidbeyMenuFactory
#Else
				ft = FactoryType.WinFormsMenuFactory
#End If
            menuFactory = MenuLoader.CreateFactory(ft, ApplicationMain.menuNamespace, New String() {maintoolbarResource}, New String() {menuResource}, ApplicationMain.IconResources, Me)

            If Not menuFactory.ToolBars Is Nothing Then
                Me.Controls.AddRange(menuFactory.ToolBars)
            End If

            If Not menuFactory.Menus Is Nothing Then
                If GetType(Menu).IsInstanceOfType(menuFactory.Menus(0)) Then
                    Menu = CType(menuFactory.Menus(0), MainMenu)
                Else
                    Me.Controls.Add(CType(menuFactory.Menus(0), Control))
                End If
            End If


        Catch ex As Exception
            Trace.WriteLine("Unable to create menu factory due to the following error:")
            Trace.WriteLine(ex.ToString())
            Return False
        End Try
        Return True
    End Function
    '/ <summary>
    '/    Clean up any resources being used.
    '/ </summary>
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub 'Dispose


    '/ <summary>
    '/    Required method for Designer support - do not modify
    '/    the contents of this method with the code editor.
    '/ </summary>
    Private Sub InitializeComponent()
        Me.SuspendLayout()
        '
        'MainWindow
        '
        Me.BorderColor = System.Drawing.Color.FromArgb(CType(CType(17, Byte), Integer), CType(CType(158, Byte), Integer), CType(CType(218, Byte), Integer))
        Me.CaptionForeColor = System.Drawing.Color.FromArgb(CType(CType(17, Byte), Integer), CType(CType(158, Byte), Integer), CType(CType(218, Byte), Integer))
        Me.ClientSize = New System.Drawing.Size(288, 264)
        Me.DropShadow = True
        Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle
        Me.MaximizeBox = False
        Me.MinimizeBox = False
        Me.Name = "MainWindow"
        Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen
        Me.ResumeLayout(False)

    End Sub 'InitializeComponent




    Sub StandardStatusBar(ByVal sender As Object, ByVal e As EventArgs)
        statusBarPanel.Text = "Ready"
    End Sub 'StandardStatusBar


    Public Sub UpdateLastFiles()
        If Not (lastfiles Is Nothing) Then
            lastfiles.MenuItems.Clear()
            Dim tmp As New MenuItem("last files")
            tmp.Enabled = False
            lastfiles.MenuItems.Add(tmp)
        End If
    End Sub 'UpdateLastFiles

End Class 'MainWindow 