#Region "Copyright Syncfusion Inc. 2001 - 2006"
'
'  Copyright Syncfusion Inc. 2001 - 2006. All rights reserved.
'
'  Use of this code is subject to the terms of our license.
'  A copy of the current license can be obtained at any time by e-mailing
'  licensing@syncfusion.com. Any infringement will be prosecuted under
'  applicable laws. 
'
#End Region

Imports System
Imports System.Diagnostics
Imports System.Drawing
Imports System.Collections
Imports System.ComponentModel
Imports System.Windows.Forms

Imports Syncfusion.Windows.Forms
Imports Syncfusion.Windows.Forms.Grid


'/ <summary>
'/    Summary description for RecordFrame.
'/ </summary>

Public Class RecordFrame
    Inherits Syncfusion.Windows.Forms.MetroForm
   '/ <summary>
   '/    Required designer variable.
   '/ </summary>
   Private components As System.ComponentModel.Container
   
    Private WithEvents recordNavigationControl1 As GridRecordNavigationControl
    Private grid1 As SampleGrid
    Private model As GridModel
   
   'private bool inUpdate = false;
   'private int savedRecord = -1;
   Public Sub New()
        model = New GridModel()
        SampleGrid.SetupGridModel(model)
        InitializeComponent()
        Me.grid1.Model = model
        Me.grid1.CurrentCell.MoveTo(1, 1)
   End Sub 'New
   
   '/ <summary>
   '/    Clean up any resources being used.
   '/ </summary>
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub 'Dispose


    '/ <summary>
    '/    Required method for Designer support - do not modify
    '/    the contents of this method with the code editor.
    '/ </summary>
    Private Sub InitializeComponent()
        Dim GridCellInfo1 As Syncfusion.Windows.Forms.Grid.GridCellInfo = New Syncfusion.Windows.Forms.Grid.GridCellInfo()
        Me.grid1 = New Syncfusion.Samples.GridPad.SampleGrid()
        Me.recordNavigationControl1 = New Syncfusion.Windows.Forms.Grid.GridRecordNavigationControl()
        Me.recordNavigationControl1.SuspendLayout()
        Me.SuspendLayout()
        '
        'grid1
        '
        Me.grid1.AllowDragSelectedCols = True
        Me.grid1.AllowDragSelectedRows = True
        Me.grid1.BackColor = System.Drawing.Color.White
        Me.grid1.ColCount = 0
        Me.grid1.DefaultColWidth = 0
        Me.grid1.DefaultGridBorderStyle = Syncfusion.Windows.Forms.Grid.GridBorderStyle.Solid
        Me.grid1.DefaultRowHeight = 0
        Me.grid1.ExcelLikeCurrentCell = True
        Me.grid1.ExcelLikeSelectionFrame = True
        Me.grid1.FillSplitterPane = True
        Me.grid1.Font = New System.Drawing.Font("Verdana", 8.25!)
        Me.grid1.ForeColor = System.Drawing.SystemColors.WindowText
        GridCellInfo1.Col = -1
        GridCellInfo1.Row = -1
        GridCellInfo1.StyleInfo.Font.Facename = "Verdana"
        GridCellInfo1.StyleInfo.TextColor = System.Drawing.Color.MidnightBlue
        Me.grid1.GridCells.AddRange(New Syncfusion.Windows.Forms.Grid.GridCellInfo() {GridCellInfo1})
        Me.grid1.GridVisualStyles = Syncfusion.Windows.Forms.GridVisualStyles.Metro
        Me.grid1.HorizontalScrollTips = True
        Me.grid1.HorizontalThumbTrack = True
        Me.grid1.Location = New System.Drawing.Point(0, 0)
        Me.grid1.Name = "grid1"
        Me.grid1.Properties.GridLineColor = System.Drawing.Color.FromArgb(CType(CType(208, Byte), Integer), CType(CType(215, Byte), Integer), CType(CType(229, Byte), Integer))
        Me.grid1.RowCount = 0
        Me.grid1.Size = New System.Drawing.Size(263, 241)
        Me.grid1.SmartSizeBox = False
        Me.grid1.ThemesEnabled = True
        Me.grid1.VerticalScrollTips = True
        '
        'recordNavigationControl1
        '
        Me.recordNavigationControl1.AllowAddNew = False
        Me.recordNavigationControl1.Controls.Add(Me.grid1)
        Me.recordNavigationControl1.Dock = System.Windows.Forms.DockStyle.Fill
        Me.recordNavigationControl1.Font = New System.Drawing.Font("Microsoft Sans Serif", 10.0!, System.Drawing.FontStyle.Bold)
        Me.recordNavigationControl1.Location = New System.Drawing.Point(0, 0)
        Me.recordNavigationControl1.MaxRecord = 0
        Me.recordNavigationControl1.MinRepeatClickDelay = 15
        Me.recordNavigationControl1.Name = "recordNavigationControl1"
        Me.recordNavigationControl1.ShowToolTips = True
        Me.recordNavigationControl1.Size = New System.Drawing.Size(284, 262)
        Me.recordNavigationControl1.SplitBars = CType((Syncfusion.Windows.Forms.DynamicSplitBars.SplitRows Or Syncfusion.Windows.Forms.DynamicSplitBars.SplitColumns), Syncfusion.Windows.Forms.DynamicSplitBars)
        Me.recordNavigationControl1.TabIndex = 0
        Me.recordNavigationControl1.ThemesEnabled = True
        '
        'RecordFrame
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.CausesValidation = False
        Me.ClientSize = New System.Drawing.Size(284, 262)
        Me.Controls.Add(Me.recordNavigationControl1)
        Me.Name = "RecordFrame"
        Me.Text = "Grid Splitter"
        Me.recordNavigationControl1.ResumeLayout(False)
        Me.ResumeLayout(False)

    End Sub 'InitializeComponent


    Sub SplitterEnter(ByVal sender As Object, ByVal e As EventArgs) Handles recordNavigationControl1.Enter
        If Me.recordNavigationControl1.HasControlFocus AndAlso Not Me.recordNavigationControl1.IsValidating Then
            Me.Activate()
        End If
    End Sub 'SplitterEnter

    Sub SplitterGotFocus(ByVal sender As Object, ByVal e As EventArgs) Handles recordNavigationControl1.GotFocus
        If Me.recordNavigationControl1.IsActiveControl AndAlso Not Me.recordNavigationControl1.IsValidating Then
            Me.Activate()
        End If
    End Sub 'SplitterGotFocus 
End Class 'RecordFrame